#ifndef _zonetv_h
#define _zonetv_h

#include "tttypes.h"
#include "tttables.h"

/*
 * TZoneViewer
 *
 * This TView is a simple point array viewer
 */

class TZoneViewer :
    public TListViewer
{
public:

  TZoneViewer( const TRect &bounds, TT_PVecRecord AZone );
  virtual ~TZoneViewer();
  virtual void draw();
  virtual void handleEvent( TEvent &event );

private:

  TT_PVecRecord  Zone; // Pointer to the zone being displayed
  TT_VecRecord   Save; // A copy of the zone to highlight changes

  void Copy_Zone();
};

/*
 * TZoneWindow
 */

class TZoneWindow :
    public TWindow
{
public:

  TZoneWindow( const TRect &bounds, TT_PVecRecord AZone );

  TZoneViewer *ZoneView;
};

#endif
