/*******************************************************************
 *
 *  ttindex.h
 *
 *    TrueType index and cmap handling (specification).
 *
 *  Copyright 1996, 1997 by
 *  David Turner, Robert Wilhelm and Werner Lemberg.
 *
 *  This file is part of the FreeType project, and may only be used
 *  modified and distributed under the terms of the FreeType project
 *  license, LICENSE.TXT. By continuing to use, modify or distribute 
 *  this file you indicate that you have read the license and
 *  understand and accept it fully.
 *
 ******************************************************************/

#ifndef TTINDEX_H
#define TTINDEX_H

#include "tttypes.h"

#ifdef __cplusplus
extern "C" {
#endif

  TT_PCMapTable  TT_select_CMap( UShort           platformID,
                                 UShort           platformEncodingID,
                                 PInstance_Record instance );

  Int  TT_code_to_index( UShort           charCode,
                         TT_PCMapTable    cmapIndex,
                         PInstance_Record instance );

#ifdef __cplusplus
}
#endif

#endif


/* End */
